////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//                                  JOJOPONG                                  //
//                                                                            //
//               Programme cree par Jojosoft - Josselin Auguste               //
//                       http://jojosoft.astronomag.com                       //
//                          jojosoft@astronomag.com                           //
//                                                                            //
//             Ce jeux a ete progamme en C++ avec la librairie Allegro        //
//     Si vous trouvez des bugs, prevenez moi a l'adresse email ci-dessus     //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//Copyright (C) 2001 Josselin Auguste
//Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les 
//termes de la Licence Publique Generale GNU publiee par la Free Software Foundation.
//Ce programme est distribue car potentiellement utile, mais SANS AUCUNE GARANTIE, ni
//explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation 
//dans un but specifique.
//Reportez-vous a la Licence Publique Generale GNU pour plus de details.
//Une copie francaise de la license GPL est disponible sur le site JoJoSoft.
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//En-tetes//////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
#define VERSION 1.2

#define ROUGE makecol(255,64,64)
#define ORANGE makecol(255,155,68)
#define BLEU makecol(64,64,255)
#define NB_STAR 200
#define INC_RAQUETTE 10

#include <allegro.h>
#include <time.h>
#include "jojopong.h"

////////////////////////////////////////////////////////////////////////////////
//Prototypes////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
void fade(void);
void clear_keys(void);
void init(void);
void init_ball(void);
void reinit(void);
void increment_target_game_time(void);
void menu(void);
void jeux(void);
void logic(void);
void draw(void);
void background(void);
void help(void);
void resume(void);

////////////////////////////////////////////////////////////////////////////////
//Declarations//////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
struct joueur
{
	int y;
	int score;
} j1, j2;

struct s_star
{
	int flag;
	int x,y,z;
	int ecran_x,ecran_y;
} star[NB_STAR];

int endbox_aff,mode,difficulte;
int xball,yball,dx,dy;
int musique=-1;
int coeff=1;
int quitmenu=0;
int quitgame=0;
int quitjeux=0;
volatile int target_game_time = 0;

BITMAP *buffer;
BITMAP *aide;
BITMAP *balle;
BITMAP *endbox;
BITMAP *logo;
BITMAP *mouse;
BITMAP *raquette1;
BITMAP *raquette2;
SAMPLE *tape;
MIDI *song;
DATAFILE *data;

////////////////////////////////////////////////////////////////////////////////
//Main//////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
int main(void)
{
	allegro_init();
	install_keyboard();
	install_mouse();
	set_color_depth(16);
	if(install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, "pong") != 0) { musique = -1; }
	if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)<0)
	{
		set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		allegro_message("This program can not be initialized\n");
		exit(1);
	}

	init();
	while(!quitgame)
	{
		reinit();
		fade();
		menu();
		jeux();
	}

	if(musique == 1) { stop_midi(); }
	/*destroy_bitmap(aide);
	destroy_bitmap(buffer);
	destroy_bitmap(balle);
	destroy_bitmap(endbox);
	destroy_bitmap(logo);
	destroy_bitmap(mouse);
	destroy_bitmap(raquette1);
	destroy_bitmap(raquette2);*/
	allegro_exit();

	return 0;
}
END_OF_MAIN();

////////////////////////////////////////////////////////////////////////////////
//Fonctions/////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
void fade()
{
	int alpha;
	BITMAP* masque=create_bitmap(800,600);
	for(alpha=0;alpha<256;alpha+=8)
	{
		set_trans_blender(0,0,0,alpha);
		draw_trans_sprite(buffer,masque,0,0);
		vsync();
		blit(buffer,screen,0,0,0,0,SCREEN_W,SCREEN_H);
	}
	destroy_bitmap(masque);
}
END_OF_FUNCTION(fade);

void clear_keys()
{
	int c;
	for (c=0;c < 128;c++)
		key[c] = FALSE;

	clear_keybuf();
}

void init(void)
{
	srand((unsigned) time(NULL));
	aide=create_bitmap(400,300);
	buffer=create_bitmap(640,480);

	data=load_datafile("jojopong.dat");
	if(!data)
	{
		set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		allegro_message("Error loading 'jojopong.dat'\n");
		exit(1);
	}
	balle=(BITMAP *) data[g_balle].dat;
	endbox=(BITMAP *) data[g_endbox].dat;
	logo=(BITMAP *) data[g_logo].dat;
	mouse=(BITMAP *) data[g_mouse].dat;
	raquette1=(BITMAP *) data[g_raquette1].dat;
	raquette2=(BITMAP *) data[g_raquette2].dat;
	tape=(SAMPLE *) data[g_tape].dat;
	song=(MIDI *) data[g_theme].dat;
}

void init_ball(void)
{
	int v;
	xball=320;
	yball=240;
	dx=2;
	dy=2;
	v=rand()%2;
	if(v == 0) { dx=-dx; }
	v=rand()%2;
	if(v == 0) { dy=-dy; }
}

void reinit(void)
{
	remove_int(increment_target_game_time);
	remove_timer();

	j1.y=160;
	j1.score=0;
	j2.y=160;
	j2.score=0;
	difficulte=difficulte/10;

	init_ball();

	endbox_aff=0;
	target_game_time=0;

	quitgame=0;
	quitjeux=0;
	quitmenu=0;
}

void increment_target_game_time()
{
	target_game_time++;
}
END_OF_FUNCTION(increment_target_game_time);

void menu(void)
{
	float version=VERSION;
	
	clear_bitmap(buffer);
	set_mouse_range(0,0,640,480);
	set_mouse_sprite(mouse);
	position_mouse(320,240);
	do
	{
		clear_bitmap(buffer);
		background();
		masked_blit(logo,buffer,0,0,0,0,logo->w,logo->h);
		textprintf(buffer,font,2,470,BLEU,"By Jojosoft - Version %.2f",version);
		textout(buffer,font,"Nombre de joueurs :",55,254,ORANGE);
		textout(buffer,font,"1  2",218,260,ORANGE);
		rect(buffer,215,245,225,255,ORANGE);
		rect(buffer,238,245,248,255,ORANGE);
		textout(buffer,font,"Difficulte :",55,285,ORANGE);
		rect(buffer,160,276,170,286,ORANGE);
		rect(buffer,183,276,193,286,ORANGE);
		rect(buffer,207,276,217,286,ORANGE);
		rect(buffer,232,276,242,286,ORANGE);
		textout(buffer,font,"1  2  3  4",163,291,ORANGE);
		rect(buffer,120,315,130,325,ORANGE);
		textout(buffer,font,"Musique",55,316,ORANGE);

		rect(buffer,280,383,360,403,ORANGE);
		textout_centre(buffer,font,"Jouer",320,390,ORANGE);
		textout(buffer,font,"F1 -> help",2,2,BLEU);

		show_mouse(buffer);

		if(mouse_x > 120 && mouse_x < 130 && mouse_y > 315 && mouse_y < 325)
		{
			rect(buffer,121,316,129,324,ROUGE);
			if(mouse_b & 1) { musique = -musique; }
		}

		if(mouse_x > 215 && mouse_x < 225 && mouse_y > 245 && mouse_y < 255)
		{
			rect(buffer,216,246,224,254,ROUGE);
			if(mouse_b & 1) { mode = 1; }
		}

		if(mouse_x > 238 && mouse_x < 248 && mouse_y > 245 && mouse_y < 255)
		{
			rect(buffer,239,246,247,254,ROUGE);
			if(mouse_b & 1) { mode = 2; }
		}

		if(mouse_x > 160 && mouse_x < 170 && mouse_y > 276 && mouse_y < 286)
		{
			rect(buffer,161,277,169,285,ROUGE);
			if(mouse_b & 1) { difficulte = 4; }
		}

		if(mouse_x > 183 && mouse_x < 193 && mouse_y > 276 && mouse_y < 286)
		{
			rect(buffer,184,277,192,285,ROUGE);
			if(mouse_b & 1) { difficulte = 3; }
		}

		if(mouse_x > 207 && mouse_x < 217 && mouse_y > 276 && mouse_y < 286)
		{
			rect(buffer,208,277,216,285,ROUGE);
			if(mouse_b & 1) { difficulte = 2; }
		}

		if(mouse_x > 232 && mouse_x < 242 && mouse_y > 276 && mouse_y < 286)
		{
			rect(buffer,233,277,241,285,ROUGE);
			if(mouse_b & 1) { difficulte = 1; }
		}

		if(mouse_x > 280 && mouse_x < 360 && mouse_y > 383 && mouse_y < 403 && mouse_b & 1)
		{
			if((mode == 1) && (difficulte >= 1 && difficulte <= 4)) { quitmenu = 1; }
			if(mode == 2) { quitmenu = 1; }
		}

		if(mouse_x > 280 && mouse_x < 360 && mouse_y > 383 && mouse_y < 403)
		{
			rect(buffer,279,382,361,404,ROUGE);
		}

		if(mode == 1)
		{
			line(buffer,216,246,224,254,ROUGE);
			line(buffer,216,254,224,246,ROUGE);
		}
		if(mode == 2)
		{
			line(buffer,239,246,247,254,ROUGE);
			line(buffer,239,254,247,246,ROUGE);
		}
		if(difficulte == 4)
		{
			line(buffer,161,277,169,285,ROUGE);
			line(buffer,161,285,169,277,ROUGE);
		}
		if(difficulte == 3)
		{
			line(buffer,184,277,192,285,ROUGE);
			line(buffer,184,285,192,277,ROUGE);
		}
		if(difficulte == 2)
		{
			line(buffer,208,277,216,285,ROUGE);
			line(buffer,208,285,216,277,ROUGE);
		}
		if(difficulte == 1)
		{
			line(buffer,233,277,241,285,ROUGE);
			line(buffer,233,285,241,277,ROUGE);
		}
		if(musique == 1)
		{
			line(buffer,121,316,129,324,ROUGE);
			line(buffer,129,316,121,324,ROUGE);
		}

		vsync();
		blit(buffer,screen,0,0,0,0,640,480);

		if(key[KEY_1]) { mode = 1; }
		if(key[KEY_2]) { mode = 2; }
		if(key[KEY_3]) { difficulte = 4; }
		if(key[KEY_4]) { difficulte = 3; }
		if(key[KEY_5]) { difficulte = 2; }
		if(key[KEY_6]) { difficulte = 1; }
		if(key[KEY_F5]) { musique = -1; }
		if(key[KEY_F6]) { musique = 1; }
		if(key[KEY_ESC]) { quitmenu=1; quitjeux=1; quitgame=1; }
		if(key[KEY_ENTER] && (mode == 1 || mode == 2) && (difficulte >= 1 && difficulte <= 4)) { difficulte=difficulte*10; quitmenu=1; }
		if(key[KEY_F1]) { help(); }
		clear_keys();
	} while(quitmenu == 0);
	clear_keys();
}

void jeux()
{
	int actual_game_time=0, ok_to_draw = TRUE;

	if(quitjeux) return;

	if(musique == 1) { play_midi(song,1); }
	clear_bitmap(buffer);

	LOCK_VARIABLE(target_game_time);
	LOCK_FUNCTION(increment_target_game_time);

	install_int_ex(increment_target_game_time, BPS_TO_TIMER(100));

	show_mouse(NULL);

	do
	{
		while(actual_game_time < target_game_time)
		{
			actual_game_time++;
			ok_to_draw=TRUE;
		}
		if(ok_to_draw)
		{
			logic();
			draw();
			ok_to_draw=FALSE;
		}
	} while(!quitjeux);
}

void logic(void)
{
	clear_bitmap(buffer);

	//tape la raquette du joueur 1
	if((xball+dx <= 15+10) && (yball+dy >= j1.y) && (yball+dy <= j1.y+80))
	{
		if(musique == 1) { play_sample(tape,255,128,1000,0); }
		dx=-dx;
	}
	//tape la raquette du joueur 2
	if((xball+dx >= 610) && (yball+dy >= j2.y) && (yball+dy <= j2.y+80))
	{
		if(musique == 1) { play_sample(tape,255,128,1000,0); }
		dx=-dx;
	}
	//tape les bords haut et bas
	if((yball+dy <= 10) || (yball+dy >= 470))
	{
		dy=-dy;
	}
	//sort de l'ecran
	if((xball+dx <= 0) || (xball+dx >= 640))
	{
		if(xball+dx <= 0) { j2.score++; }
		if(xball+dx >= 640) { j1.score++; }
		init_ball();
	}
	xball=xball+dx;
	yball=yball+dy;

	//IA
	if(mode == 1 && coeff == difficulte)
	{
		if((yball+dy) < j2.y && j2.y > 0) { j2.y=j2.y-80; }
		if((yball+dy) > j2.y+80 && j2.y < 400) { j2.y=j2.y+80; }
		coeff=0;
	}
	coeff++;

	if(key[KEY_A] && j1.y > 0)
	{
		j1.y=j1.y-INC_RAQUETTE;
	}
	if(key[KEY_Z] && j1.y < 479-INC_RAQUETTE)
	{
		j1.y=j1.y+INC_RAQUETTE;
	}
	if(mode == 2)
	{
		if(key[KEY_UP] && j2.y > 0)
		{
			j2.y=j2.y-INC_RAQUETTE;
		}
		if(key[KEY_DOWN] && j2.y < 479-INC_RAQUETTE)
		{
			j2.y=j2.y+INC_RAQUETTE;
		}
	}
	if(key[KEY_PRTSCR])
	{
		PALETTE palette;
		get_palette(palette);
		save_bitmap("capture.pcx",buffer,palette);
	}
	//Endbox
	if(key[KEY_ESC])
	{
		if(musique == 1) { midi_pause(); }
		endbox_aff = 1;
		set_mouse_sprite(mouse);
		set_mouse_range(0,0,endbox->w-1,endbox->h-1);
		position_mouse((endbox->w)>>1,(endbox->h)>>1);

		show_mouse(endbox);
		do
		{
			clear_keys();
			
			blit(endbox,screen,0,0,178,181,640,480);
			if(mouse_y > 94 && mouse_y < 117)
			{
				if(mouse_x > 0 && mouse_x < 139)
				{
					if(mouse_b & 1) { endbox_aff=0; quitjeux=1; }
				}
				if(mouse_x > 144 && mouse_x < 283)
				{
					if(mouse_b & 1) { if(musique == 1) { midi_resume(); } endbox_aff = 0; }
				}
			}
			if(key[KEY_ESC]) { if(musique == 1) { midi_resume(); } endbox_aff = 0; }
			if(key[KEY_ENTER]) { endbox_aff=0; quitjeux=1; }
		} while(endbox_aff != 0);
		show_mouse(NULL);
	}
	clear_keys();
}

void draw(void)
{
	clear_bitmap(buffer);
	background();
	textprintf(buffer,font,10,20,ROUGE,"Joueur 1 : %d",j1.score);
	if(mode == 1)
	{
		textprintf(buffer,font,10,35,ROUGE,"Ordinateur : %d",j2.score);
	} else {
		textprintf(buffer,font,10,35,ROUGE,"Joueur 2 : %d",j2.score);
	}
	draw_sprite(buffer,balle,xball-((balle->w)>>1),yball-((balle->h)>>1));
	draw_sprite(buffer,raquette1,10,j1.y);
	draw_sprite(buffer,raquette2,625,j2.y);
	vsync();
	blit(buffer,screen,0,0,0,0,640,480);
}

void background()
{
	int i;
	for(i=0;i<NB_STAR;i++)
	{
		//initialisation
		if(!star[i].flag)
		{
			star[i].x=rand()%320-160;
			star[i].y=rand()%240-120;
			star[i].z=rand()%(-110)-100;
			star[i].flag=1;
		}
		star[i].z++;
		if(star[i].z > -10)
		{
			star[i].x=rand()%320-160;
			star[i].y=rand()%240-120;
			star[i].z=-100;
		}

		//Projection
		star[i].ecran_x=320+100*star[i].x/star[i].z;
		star[i].ecran_y=240+100*star[i].y/star[i].z;
		putpixel(buffer,star[i].ecran_x,star[i].ecran_y,makecol(192+star[i].z,192+star[i].z,192+star[i].z));
	}
}

void help(void)
{
	do
	{
		clear_bitmap(aide);
		clear_keys();
		rect(aide,0,0,399,299,95);
		textout_centre(aide,font,"HELP",200,10,BLEU);
		textout(aide,font,"Entree -> valider",10,50,BLEU);
		textout(aide,font,"Echap -> annuler",10,65,BLEU);
		textout(aide,font,"1 a 6 -> selectionner les options du menu",10,80,BLEU);
		textout(aide,font,"F5 -> musique off",10,95,BLEU);
		textout(aide,font,"F6 -> musique on",10,110,BLEU);
		textout(aide,font,"Q et W -> bouger la raquette 1",10,130,BLEU);
		textout(aide,font,"haut et bas -> bouger la raquette 2",10,145,BLEU);
		textout_centre(aide,font,"JOJOPONG est un programme cree par Jojosoft",200,200,BLEU);
		blit(aide,screen,0,0,120,110,400,300);
	} while((!key[KEY_F1]));
}

